unit Unit_Pie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, TeeComma, ExtCtrls, TeeProcs, Chart,
  TeeAntiAlias, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TPieSeries;
    ChartTool1: TAntiAliasTool;
    Label1: TLabel;
    TeeCommander1: TTeeCommander;
    procedure FormCreate(Sender: TObject);
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeCanvas;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ColorPalettes.ApplyPalette(Chart1,OperaPalette);
  Chart1.Gradient.Visible := true;
  Chart1.Gradient.EndColor := rgb(225,225,225);

  Chart1.Title.Text.Text := 'Product Lines';
  Chart1.Title.Font.Color := RGB(128,128,0);
  Chart1.Title.Font.Size := 18;
  Chart1.Title.Alignment := taLeftJustify;

  Chart1.Legend.Alignment := laBottom;
  Chart1.Legend.Transparent := true;
  Chart1.Legend.Symbol.Shadow.Visible := false;

  Series1.Shadow.Visible := false;
  Series1.Pen.Visible := false;
  Series1.Gradient.Visible := true;
  Series1.Gradient.Direction := gdDiagonalDown;
  Series1.Gradient.Balance := 30;

  Series1.Marks.Symbol.Visible := true;
  Series1.Marks.Symbol.Shadow.Color := clGrayText;
  Series1.Marks.Font.Size := 14;
  Series1.Marks.Shadow.Visible := false;
  Series1.Marks.Frame.Color := rgb(202,164,136);
  Series1.Marks.Arrow.Color := rgb(216,189,169);
  Series1.Marks.Transparency := 50;
  Series1.PieMarks.LegSize := 50;

  Series1.ExplodeBiggest := 20;

  ChartTool1.Active := true;
end;

procedure TForm1.Chart1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ValueIndex, MarksIndex: Integer;
begin
  ValueIndex := Series1.Clicked(X,Y);
  MarksIndex := Series1.Marks.Clicked(X,Y);
  if ValueIndex <> -1 then
    Label1.Caption := 'Series clicked! Clicked pie slice ' + floattostr(ValueIndex)
  else if MarksIndex <> -1 then
    Label1.Caption := 'Marks clicked! Clicked pie mark ' + floattostr(MarksIndex)
  else
    Label1.Caption := 'Chart clicked!';
end;

end.
